#!/bin/bash
PATH=/bin:/sbin:/usr/bin:/usr/sbin:/usr/local/bin:/usr/local/sbin:~/bin
export PATH

#配置插件下载地址和安装目录
download_url=http://download.bt.cn/lvs
install_path=/www/server/panel/plugin/lvs

#安装
Install()
{
	
	echo '正在安装...'

	#==================================================================
	#打包插件目录上传的情况下
	#依赖安装开始
	if grep -Eqi "Ubuntu" /etc/issue || grep -Eq "Ubuntu" /etc/*-release; then
	apt-get install ipvsadm -y
	elif grep -Eqi "CentOS" /etc/issue || grep -Eq "CentOS" /etc/*-release; then
	yum install ipvsadm -y
	fi

	#依赖安装结束
	#==================================================================

	#==================================================================
	#使用命令行安装的情况下，如果使用面板导入的，请删除以下代码
	
	#创建插件目录
	mkdir -p $install_path

	#开始下载文件
#	wget -O $install_path/lvs_main.py  $download_url/lvs_main.py
#	wget -O $install_path/index.html $download_url/index.html
#	wget -O $install_path/info.json $download_url/info.json
#	wget -O $install_path/icon.png $download_url/icon.png
#	wget -O $install_path/install.sh $download_url/install.sh
#	wget -O $install_path/lvs_dr.sh $download_url/lvs_dr.sh
#	wget -O $install_path/lvs_rs.sh $download_url/lvs_rs.sh
	chmod +x  $install_path/lvs_dr.sh
	chmod +x  $install_path/lvs_rs.sh
	cp -a $install_path/icon.png "/www/server/panel/BTPanel/static/img/soft_ico/ico-lvs.png"
	#文件下载结束
	#==================================================================
	echo '================================================'
	echo '安装完成'
}

#卸载
Uninstall()
{
	rm -rf $install_path
	yum remove -y ipvsadm
}

#操作判断
if [ "${1}" == 'install' ];then
	Install
elif [ "${1}" == 'uninstall' ];then
	Uninstall
else
	echo 'Error!';
fi
