#!/bin/bash
#Author:xf
# LVS script for VS/DR
dev=$2
VIP=$3
RIP1=$4
RIP2=$5
PORT=$6
method=$7


case "$1" in
    start)
      /sbin/ifconfig $dev:0 down
      /sbin/ifconfig $dev:0 $VIP broadcast $VIP netmask 255.255.255.255 up
      /sbin/route add -host $VIP dev $dev:0
      echo 1 > /proc/sys/net/ipv4/ip_forward

      /sbin/ipvsadm -C

      /sbin/ipvsadm -A -t $VIP:$PORT -s $method

      /sbin/ipvsadm -a -t $VIP:$PORT -r $RIP1 -g
      /sbin/ipvsadm -a -t $VIP:$PORT -r $RIP2 -g
      /bin/touch /var/lock/subsys/ipvsadm &> /dev/null
    ;;
    stop)
      echo 0 > /proc/sys/net/ipv4/ip_forward
      /sbin/ipvsadm -C
      /sbin/ifconfig $dev:0 down
      /sbin/route del $VIP

      /bin/rm -f /var/lock/subsys/ipvsadm

      echo "ipvs is stopped..."
    ;;
    status)
    if [ ! -e /var/lock/subsys/ipvsadm ]; then
        echo "ipvsadm is stopped ..."
      else
        echo "ipvs is running ..."
        ipvsadm -L -n
      fi
    ;;
    *)
      echo "Usage: $0 {start|stop|status}"
    ;;
esac

