#!/usr/bin/python
# coding: utf-8
# +-------------------------------------------------------------------
# | 宝塔Linux面板
# +-------------------------------------------------------------------
# | Copyright (c) 2015-2099 宝塔软件(http://bt.cn) All rights reserved.
# +-------------------------------------------------------------------
# | Author: xxx <xxxx@qq.com>
# +-------------------------------------------------------------------

#+--------------------------------------------------------------------
#|   宝塔第三方应用开发DEMO
#+--------------------------------------------------------------------
import sys,os,json

#设置运行目录
os.chdir("/www/server/panel")

#添加包引用位置并引用公共包
sys.path.append("class/")
import time, psutil, random, os, urllib, binascii, json, re, sys, threading, db
import public
from flask import session
from system import system

#from common import dict_obj
#get = dict_obj();


#在非命令行模式下引用面板缓存和session对象
if __name__ != '__main__':
    from BTPanel import cache,session

    #设置缓存(超时10秒) cache.set('key',value,10)
    #获取缓存 cache.get('key')
    #删除缓存 cache.delete('key')

    #设置session:  session['key'] = value
    #获取session:  value = session['key']
    #删除session:  del(session['key'])




class lvs_main:
    __plugin_path = "/www/server/panel/plugin/lvs/"
    __config = None
    __save_config="/www/server/panel/plugin/lvs/rule_lvs"
    #ipvsadm --set 5 10 300
    #构造方法
    def  __init__(self):
        if not os.path.exists(self.__save_config):
            public.WriteFile(self.__save_config,"")

    #自定义访问权限检查
    #一但声明此方法，这意味着可以不登录面板的情况下，直接访问此插件，由_check方法来检测是否有访问权限
    #如果您的插件必需登录后才能访问的话，请不要声明此方法，这可能导致严重的安全漏洞
    #如果权限验证通过，请返回True,否则返回 False 或 public.returnMsg(False,'失败原因')
    #示例未登录面板的情况下访问get_logs方法： /public?action=a&name=demo&fun=get_logs&token=123456

    
    def _check(self,args):
        token = '123456'
        limit_addr = ['192.168.1.2','192.168.1.3']
        if args.token != token: return public.returnMsg(False,'Token验证失败!')
        if not args.client_ip in limit_addr: return public.returnMsg(False,'IP访问受限!')
        return True

    def GetDevConf(self):
        devName = 'eth0';
        cfile = '/etc/sysconfig/network-scripts/ifcfg-' + devName;
        try:
            if not os.path.exists(cfile): devName = 'eno16777736';
            if not os.path.exists(cfile): devName = 'eno1';
            if not os.path.exists(cfile): devName = 'ens33';
            if not os.path.exists(cfile):
                devName = public.ExecShell("ip add |grep LOWER_UP|grep -v lo|sed 's/://g'|awk '{print $2}'")[0].split()[0].strip()

            cfile = '/etc/sysconfig/network-scripts/ifcfg-' + devName
            return cfile, devName
        except:
            return cfile, devName

    def GetInfo(self,args):
        config_file = self.__plugin_path + 'config.json'
        f_body = public.ReadFile(config_file)
        return json.loads(f_body)

    def SetAddress(self, get):
        if not self.CheckIp(get.vip): return public.returnMsg(False, 'IP地址不合法!');
        if not self.CheckIp(get.rs1): return public.returnMsg(False, 'IP地址不合法!');
        if not self.CheckIp(get.rs2): return public.returnMsg(False, 'IP地址不合法!');
        tmp=set()
        tmp.add(get.vip)
        tmp.add(get.rs1)
        tmp.add(get.rs2)
        if len(tmp) !=3 :return public.returnMsg(False, '重复ip地址!');
        if get.method not in ['sh','wrr','lc','wlc','lblc','lblcr','dh','rr','nq','sed']:return public.returnMsg(False, '错误算法!');
        try:
            if int(get.port) <1 or int(get.port)>65535:return public.returnMsg(False, '端口错误!');
        except Exception as e:
            return public.returnMsg(False, '端口错误!');
        cfile, devName = self.GetDevConf();
        dr_file = self.__plugin_path + 'lvs_dr.sh'
        if os.path.exists(dr_file):
            self.__set_config("port",get.port)
            self.__set_config("VIP",get.vip)
            self.__set_config("RS1",get.rs1)
            self.__set_config("RS2",get.rs2)
            self.__set_config("method",get.method)
            self.__set_config("devName",devName)

            os.system("/bin/bash %s start %s %s %s %s %s %s"%(dr_file,devName,get.vip,get.rs1,get.rs2,get.port,get.method))
            public.ExecShell("/sbin/ipvsadm -S > %s"%self.__save_config)
            return public.returnMsg(True, '添加成功!');
        else:
            return public.returnMsg(False, '文件不存在，请重新安装!');

    # 验证IP合法性
    def CheckIp(self, address):
        try:
            if address.find('.') == -1: return False;
            iptmp = address.split('.');
            if len(iptmp) != 4: return False;
            for ip in iptmp:
                if int(ip) > 255: return False
            return True
        except:
            return False

    def CheckStatus(self,get):#查看状态
        if get.service=='vip':
            if os.path.exists("/var/lock/subsys/ipvsadm"):
                return {"status":True}
            return {"status":False}
        else:
            rs_file=self.__plugin_path+'lvs_rs.sh'
            vip=self.__get_config("RVIP")
            if vip and os.system("/bin/bash %s status %s"%(rs_file,vip)) == 0:
                return {"status": True}
            else:
                return {"status": False}



    def CheckConfigFile(self,get):
        if os.path.exists("/www/server/panel/plugin/lvs/config.json"):
            return {'status':True,'msg':""}
        else:
            return {'status': False, 'msg': ""}
    def change_status(self,get):
        if get.service=="vip":
            dr_file = self.__plugin_path + 'lvs_dr.sh'
            cfile, devName = self.GetDevConf();
            VIP=self.__get_config("VIP")
            status=get.status
            if status=='stop':
                msg="lvs已停止"
                os.system("/bin/bash %s stop %s %s"%(dr_file,devName,VIP))
            elif status=='restart':
                msg = "lvs已重启"
                os.system('/sbin/ipvsadm -S < %s' % self.__save_config);
            elif status=='reload':
                msg = "lvs已重载"
                os.system('/sbin/ipvsadm -S < %s' % self.__save_config);
            elif status=='start':
                msg = "lvs已启动"
                if os.path.exists("/www/server/panel/plugin/lvs/config.json"):
                    vip=self.__get_config("VIP")
                    rs1=self.__get_config("RS1")
                    rs2=self.__get_config("RS2")
                    port=self.__get_config("port")
                    method=self.__get_config("method")
                    os.system("/bin/bash %s start %s %s %s %s %s %s" % (
                    dr_file, devName,vip,rs1,rs2,port,method))
                else:
                    return {"status":True,"msg":"启动失败，请填写配置"}
            return {"status":True,"msg":msg}
        elif get.service=="rip":
            status = get.status
            vip = get.vip
            dr_file = self.__plugin_path + 'lvs_rs.sh'
            if status=='start':
                self.__set_config("RVIP",vip)
                os.system("/bin/bash %s start %s" % (dr_file,vip))
                msg="rip已启动"
            elif status=="stop":
                os.system("/bin/bash %s stop "%dr_file)
                msg="rip已停止"
            return {"status":False,'msg':msg}

    #获取面板日志列表
    #示例已登录面板的情况下访问get_logs方法：/plugin?action=a&name=demo&s=get_logs
    def get_logs(self,args):
        #处理前端传过来的参数
        if not 'p' in args: args.p = 1
        if not 'rows' in args: args.rows = 12
        if not 'callback' in args: args.callback = ''
        args.p = int(args.p)
        args.rows = int(args.rows)

        #取日志总行数
        count = public.M('logs').count()

        #获取分页数据
        page_data = public.get_page(count,args.p,args.rows,args.callback)

        #获取当前页的数据列表
        log_list = public.M('logs').order('id desc').limit(page_data['shift'] + ',' + page_data['row']).field('id,type,log,addtime').select()
        
        #返回数据到前端
        return {'data': log_list,'page':page_data['page'] }
        
    #读取配置项(插件自身的配置文件)
    #@param key 取指定配置项，若不传则取所有配置[可选]
    #@param force 强制从文件重新读取配置项[可选]
    def __get_config(self,key=None,force=False):
        #判断是否从文件读取配置
        if not self.__config or force:
            config_file = self.__plugin_path + 'config.json'
            if not os.path.exists(config_file): return None
            f_body = public.ReadFile(config_file)
            if not f_body: return None
            self.__config = json.loads(f_body)

        #取指定配置项
        if key:
            if key in self.__config: return self.__config[key]
            return None
        return self.__config

    #设置配置项(插件自身的配置文件)
    #@param key 要被修改或添加的配置项[可选]
    #@param value 配置值[可选]
    def __set_config(self,key=None,value=None):
        #是否需要初始化配置项
        config_file = self.__plugin_path + 'config.json'
        if os.path.exists(config_file):
            f_body = public.ReadFile(config_file)
            self.__config = json.loads(f_body)
        else:
            self.__config={}
        #是否需要设置配置值
        if key:
            self.__config[key] = value

        #写入到配置文件

        public.WriteFile(config_file,json.dumps(self.__config))
        return True

